// package JavaCode;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;

public class CallSNPs {
	static ReferenceSequences rs;	
	static String[] files;
	static int      chr;
	static int[]    countSnps;   // *
	static int[]    nSNPsCount;  // *
	static int[]    hSNPsCount;  // *
	static int[]    bidxAvr;     // *
	static long[][] X;           // *
	static long[]   XT;
	static long[]   XB;
	static int[][]  covered;     // *
	static int[][]  bidxHist;    // *
	
	public static void main(String[] args) throws Exception{
		// Thread.sleep(60 * 60 * 1000);
		Consensus    css;
		Parameters.resetTime();

		if (args.length < 1) {
			return;
		}
		Parameters.read(args[0]);
		
		int ux;
		int[] refSeqSize = new int[Parameters.SEQ_VAR.length];
		files            = new String[Parameters.SEQ_VAR.length];
		
		countSnps  = new int [Parameters.SEQ_VAR.length];
		nSNPsCount = new int [Parameters.SEQ_VAR.length];
		hSNPsCount = new int [Parameters.SEQ_VAR.length];
		bidxAvr    = new int [Parameters.SEQ_VAR.length];
		X          = new long[Parameters.SEQ_VAR.length][3];
		XT         = new long[Parameters.SEQ_VAR.length];
		XB         = new long[Parameters.SEQ_VAR.length];
		bidxHist   = new int [Parameters.SEQ_VAR.length][101];
		covered    = new int [Parameters.SEQ_VAR.length][10];

		for(int i = 0; i < 4; i++) {
			for(int j = 0; j < 101; j++) {
				Consensus.snpScoreHist[i][j] = 0;
			}
		}
		for(int i = 0; i < 2; i++) {
			for(int b = 0; b < 15; b++) {
				for(int j = 0; j < 101; j++) {
					Consensus.snpScoreBidx[i][b][j] = 0;
				}
			}
		}


		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			files[i]      = Parameters.ch_name1 + Parameters.SEQ_VAR[i] + Parameters.ch_name2;
			bidxAvr[i]    = 0;
			nSNPsCount[i] = 0;
			hSNPsCount[i] = 0;
			countSnps[i] = 0;
			X[i][0] = X[i][1] = X[i][2] = 0;
			XT[i] = 0;
			XB[i] = 0;
			for (int j = 0; j < 101; j++) {
				bidxHist[i][j] = 0;
			}
			for(int j = 0; j < 10; j++) {
				covered[i][j] = 0;
			}
		}
		for (int i = 0; i <= 100; i++) {
			Consensus.snpScoreHist[3][i] = Consensus.snpScoreHist[2][i] = Consensus.snpScoreHist[1][i] = Consensus.snpScoreHist[0][i] = 0;
		}
		Oligo.numberOfBACs = Parameters.SEQ_VAR.length;
		Oligo.BACs = Parameters.SEQ_VAR;
		ReferenceSequences.display = false;
		rs = new ReferenceSequences();
		Oligo.fillCode();
		ux = 0;
		ReferenceSequences.ux = ux;
		getRefSeqSize(Parameters.pathDB + Parameters.DATABASE, refSeqSize);
		for(chr = 0; chr < files.length; chr++) { // files.length
			ux = 0;
			ReferenceSequences.ux = ux;
			System.err.println(files[chr] + " :\t" + refSeqSize[chr]);
			css = new Consensus(files[chr]);
			// break;
		}
		//*
		long totalSeqSize = 0;
		long totalX = 0;
		long totalXT = 0;
		long totalXB = 0;
		long totalCountSnps = 0;
		long totalNSNPsCount = 0;
		long totalHSNPsCount = 0;
		long totalBidxAvr = 0;
		BufferedWriter reportSnps = new BufferedWriter(new FileWriter(Parameters.pathOut + "/report.snps"));
		for(int f = 0; f < Parameters.SEQ_VAR.length; f++) {
			totalSeqSize += refSeqSize[f];
			totalX += X[f][0];
			totalXT += XT[f];
			totalXB += XB[f];
			totalCountSnps += countSnps[f];
			totalNSNPsCount += nSNPsCount[f];
			totalHSNPsCount += hSNPsCount[f];
			totalBidxAvr += bidxAvr[f];
			reportSnps.write(files[f] + "\t" + refSeqSize[f] + "\t" + Parameters.trim(((double) X[f][0]) / refSeqSize[f]) + "\t" + 
					countSnps[f] + "\t" + nSNPsCount[f] + "\t" + Parameters.trim(((double) nSNPsCount[f]) * 100 / countSnps[f]) + "%\t" + 
					hSNPsCount[f] + "\t" + Parameters.trim(((double) hSNPsCount[f]) * 100 / countSnps[f]) + "%\t"+
					Parameters.trim(((float) bidxAvr[f]) / countSnps[f]) + "\n"
					);
		}
		reportSnps.write(totalX + "\t" + totalXT + "\t" + totalXB + "\n");
		reportSnps.write("Total\t" + totalSeqSize + "\t" + Parameters.trim(((double) totalX) / totalSeqSize) + "\t" + 
				totalCountSnps + "\t" + totalNSNPsCount + "\t" + Parameters.trim(((double) totalNSNPsCount * 100) / totalCountSnps) + "%\t" + 
				totalHSNPsCount + "\t" + Parameters.trim(((double) totalHSNPsCount * 100) / totalCountSnps) + "%\t" +
				Parameters.trim(((float) totalBidxAvr) / totalCountSnps) + "\n"
				);

		reportSnps.write("\n\n % of ref is covered with bases+\n\t");
		for(int i = 1; i <= covered[0].length; i++) {
			reportSnps.write(i + "\t");
		}
		reportSnps.write("\n");
		for(int f = 0; f < Parameters.SEQ_VAR.length; f++) {
			reportSnps.write(files[f] + "\t");
			for(int i = 0; i < covered[f].length; i++) {
				reportSnps.write(Parameters.trim(((double) covered[f][i] * 100) / refSeqSize[f]) + "\t");
			}
			reportSnps.write("\n");
		}

		reportSnps.write("\n bidx distrebution\n\t");
		for(int i = 1; i <= bidxHist[0].length; i++) {
			reportSnps.write(i + "\t");
		}
		reportSnps.write("\n");
		for(int f = 0; f < Parameters.SEQ_VAR.length; f++) {
			int sum = 0;
			for(int i = 0; i < bidxHist[f].length; i++) {
				sum += bidxHist[f][i];
			}
			reportSnps.write(files[f] + "\t");
			for(int i = 0; i < bidxHist[f].length; i++) {
				reportSnps.write(Parameters.trim(((double) bidxHist[f][i] * 100) / sum) + "\t");
			}
			reportSnps.write("\n");
		}
		// snpScoreBidx[0][cn][bx]++;
		int sumKnown  = 0;
		int sumNovel = 0;
		reportSnps.write("Score\tKnown\tNovel\n");
		for (int i = 0; i <= 100; i++) {
			for (int cn = 0; cn < 15; cn++) {
				sumKnown += Consensus.snpScoreBidx[0][cn][i];
				sumNovel += Consensus.snpScoreBidx[1][cn][i];
			}
			reportSnps.write(i + "\t" + Consensus.snpScoreHist[0][i] + "\t" + Consensus.snpScoreHist[1][i] + 
					"\t" + Consensus.snpScoreHist[2][i] + "\t" + Consensus.snpScoreHist[3][i] + "\t" + sumKnown + "\t" + sumNovel);
			for (int cn = 0; cn < 15; cn++) {
				reportSnps.write("\t" + Consensus.snpScoreBidx[0][cn][i] + "\t" + Consensus.snpScoreBidx[1][cn][i]);
			}
			reportSnps.write("\n");
			sumKnown = sumNovel = 0;
		}
		reportSnps.close();

		/*
		reportSnps.write("\nNovel SNPs count :\t" + nSNPsCount + "\t" + Parameters.trim(((double) nSNPsCount) * 100 / uSize)+ "%\n"); //??
		reportSnps.write("Hetero SNPs count:\t" + hSNPsCount + "\t" + Parameters.trim(((double) hSNPsCount) * 100 / uSize)+ "%\n");//??
		reportSnps.write("Bidx Average ....:\t" + Parameters.trim(((double) bidxAvr) / uSize) + "\n");
		reportSnps.write("\nX coverage .......:\t" + Parameters.trim(((double) avrCnt[0]) / uSize) + 
				"\nX coverage Forward:\t" + Parameters.trim(((double) avrCnt[1]) / uSize) +
				"\nX coverage Reverse:\t" + Parameters.trim(((double) avrCnt[2]) / uSize) + "\n\n");
		for(int i = 0; i < covered.length; i++) {
			reportSnps.write("covered% with " + (i+1) + "+ ");
			if (i < 9) 
				reportSnps.write(" ");
			reportSnps.write("bases:\t" + Parameters.trim(((double) covered[i] * 100) / uSize) + "%\n");
		}
		reportSnps.write("\n");
		for(int i = 0; i < 101; i++) {
			// reportSnps.write(bidxHist[i] + "\t");
		}
		//*/
	}

	static void getRefSeqSize(String dbfile, int[] refSeqSize) throws Exception {
		String line;
		StringTokenizer tokens;
		BufferedReader reader = new BufferedReader(new FileReader(dbfile + "refSeqSizes"));
		for (int i = 0; i < refSeqSize.length; i++) {
			line           = reader.readLine();
			tokens         = new StringTokenizer(line);	
			refSeqSize[i]      = new Integer(tokens.nextToken());
			System.err.println(files[i] + " size:\t" + refSeqSize[i]);
		}
		System.err.println();		
	}
}
