// package JavaCode;

import java.io.BufferedWriter;
import java.io.FileWriter;

/*
SLIDER: Local Short Reads DNA Sequence Alignment
Beta Release; Ver 0.1, 22th Mar. 2008
By: Nawar Malhis
Canada's Michael Smith Genome Sciences Centre
*/

public class Info {
	public static void main(String[] args) throws Exception {
		if (args.length >= 2) {
			Parameters.read(args[0]);
			long[][] weightHist = new long[2][101];
			long[]   whCount    = new long[2];
			long     totalBases = 0;
			long     totalReads = 0;
			// long     totalOligos = 0;
			long[][] count      = new long[5][6];
			long[]   countTotal = new long[2];
			long[][] countSize  = new long[2][100];
			long[]   countMM    = new long[2]; // for matched reads, count_missMatch bases
			countMM[0] = countMM[1] = countTotal[0] = countTotal[1] = 0;

			OligoFile ofile = new OligoFile(args[1], "", OligoFile.R);
			Oligo.numberOfBACs = ofile.numberOfBACs;
			Oligo.BACs = ofile.BACs;
			whCount[0] = whCount[1] = weightHist[0][100] = weightHist[1][100] = 0;
			for (int i = 0; i < 100; i++) {
				weightHist[0][i] = weightHist[1][i] = countSize[0][i] = countSize[1][i] = 0;
			}
			
			// totalOligos = 
			ofile.info(1, count, countTotal, countSize, countMM, weightHist, whCount);
			
			System.err.println("NumberOfReads:\t" + countTotal[0] + "\tPETs:\t" + countTotal[1] + "\t" + 
					Parameters.trim(100 * (float) countTotal[1] / (float) countTotal[0]) + "%\t" + 
					Parameters.trim(100 * (float) countTotal[1] / (float) (count[3][0] * 2)) + "%\n");
			System.err.println(".......:\tS0\tS1\tS0+S1\tS0&S1\tS0|S1");
			System.err.println("Total .:\t" + count[0][0] + "\t" + count[1][0] + "\t" + count[2][0] + "\t" + count[3][0] + "\t" + count[4][0]);
			System.err.println("Crisp .:\t" + count[0][1] + "\t" + count[1][1] + "\t" + count[2][1] + "\t" + count[3][1] + "\t" + count[4][1]);
			System.err.println("LQ ....:\t" + count[0][2] + "\t" + count[1][2] + "\t" + count[2][2] + "\t" + count[3][2] + "\t" + count[4][2]);
			System.err.println("UM ....:\t" + count[0][3] + "\t" + count[1][3] + "\t" + count[2][3] + "\t" + count[3][3] + "\t" + count[4][3]);
			System.err.println("UMCrisp:\t" + count[0][4] + "\t" + count[1][4] + "\t" + count[2][4] + "\t" + count[3][4] + "\t" + count[4][4]);
			System.err.println("UMLQ ..:\t" + count[0][5] + "\t" + count[1][5] + "\t" + count[2][5] + "\t" + count[3][5] + "\t" + count[4][5]);
			if (countMM[0] > 0) {
				if (countMM[0] < count[0][0] * Parameters.seedSize / 2) {
					System.err.println("MMs ...:\t" + countMM[0]  + "\t" + countMM[1]);
					System.err.print  ("MMs/Rds:\t" + Parameters.trim((float) countMM[0] / (float) count[0][0]) + "\t");
					if(count[1][0] > 0)
						System.err.println(Parameters.trim((float) countMM[1] / (float) count[1][0]));
					else 
						System.err.println("0");
					for (int i = 0; i < 100; i++) {
						if(countSize[0][i] + countSize[1][i] > 0) {
							totalBases += (i * (countSize[0][i] + countSize[1][i]));
							totalReads += countSize[0][i] + countSize[1][i];
							System.err.println(i + "\t" + countSize[0][i] + "\t" + countSize[1][i]);
						}
					}
					System.err.println("Average read Size:\t" + Parameters.trim(((double) totalBases) / totalReads));
				} else {
					System.err.print  ("UQSize%:\t" + Parameters.trim((float) countMM[0] / (float) count[0][0]) + "\t");
					if(count[1][0] > 0)
						System.err.println(Parameters.trim((float) countMM[0] / (float) count[1][0]));
					else 
						System.err.println("0");
				}
			} 
			// System.err.println(whCount[0] + "\t" + whCount[1]);
			BufferedWriter writer = new BufferedWriter(new FileWriter(args[1] + "/weightHist"));
			for (int i = 0; i < 101; i++) {
				writer.write(i + "\t" + Parameters.trim(((float)weightHist[0][i]) * 100/whCount[0]) + "\t" + 
						Parameters.trim(((float) weightHist[1][i]) * 100/whCount[1]) + "\n");
			}
			writer.close();
			ofile.close();
		}
	}
}
