// package JavaCode;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.StringTokenizer;
/*
	SLIDER: Local Short Reads DNA Sequence Alignment
	Beta Release; Ver 0.1, 22th Mar. 2008
	By: Nawar Malhis
	Canada's Michael Smith Genome Sciences Centre
 */

public class Parameters {
	public static boolean debug = false;
	public static int[]   q_Cal = {26, 26, 27, 27, 27, 28, 28, 29, 29, 29, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 28, 28, 28, 28, 28,
								  26, 26, 26, 26, 26, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 23, 23, 23, 23, 23, 
		                          23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 23, 23, 23, 23, 23,
		                          23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23};
	/*
	public static int[]   q_Cal = {26, 26, 27, 27, 27, 28, 28, 29, 29, 29, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
								  29, 29, 29, 29, 29, 29, 28, 28, 28, 28, 27, 27, 27, 27, 27, 26, 26, 26, 26, 26, 25, 25, 25, 25, 25, 
		                          24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 23, 23, 23, 23, 23,
		                          23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23};
	 */
	public static float   cutSNP0 = (float) 0.80;
	public static float   cutSNP1 = (float) 0.10;
	public static float   cutSNPd = (float) 0.15;
	public static float   qEffect = (float) 0.20;
	public static float   setMaxWeight = (float) 0.9;
	public static float   weightFactor = (float) 0.5;
	public static float   noiseBase = 0.9f;
	public static int     noiseWindowSize = 10;
	public static int     oneSnpEach   = 100000;
	public static float   minInfo = (float) 3.5;
	public static int     prbCallUse = 2000000; // 10 M reads are used to generate prbCall table

	public static int     exSize       = 10;
	public static int     snpWeight         = 3;
	public static int     maxSNPCoverage = 254;
	public static boolean displaySubs       = true;
	public static boolean displayExtensions = true;
	public static boolean displayCover      = true;
	public static boolean ziped = true;
	static       int     seqSegPRB     = 30;
	static       float   seqSegNucP    = (float) 0.999; // used by Seq to determine UD bases 
	static       float   minWeight     = (float) 0.001; // used in CreateSequences and in filtering ol1
	static final int     maxUDN        = 9;            // used by Seq to determine if a sequence will have more than one copy 
	// public static TranscriptAdaptor ta;
	static		 boolean multi       = true;    // for multi match output
	static final boolean storeConsensus = false;
	static final boolean storeCoverage  = false;
    static final int     now         = 3;
    static       int     dbOligoSize = 93;      // max oligo size
    static final int     wordSize    = 31;
    static final int     MMBRK       = 60;      // max number of mm
    static       int     edgeBIdxMin = 2;
    static       int     edgeBIdx    = 20;
    static       int     petSpanMin  = 0; // from end to end
    static       int     petSpanMax  = 0; // from end to end
    static       int     petSpanVar  = 100; // from end to end
    static       int     petSpanMost     = 100; // from end to end
    static       int     picCut      = 3;
	static		 boolean skipValue;
    static       int     snpBidxCenter= 42;
    static		 int     snpBidxSprd = 20;
	static       int     skipCycles  = 0;
	static final int     petHistSize = 1000;
	static final int     dbHistSize  = 100;
	static       int     mapAdjust   = 0;
	static       int     expandMismatches = 3;    // EXPAND max mismatches
	static       float   petExtra     = (float) 0.2;
	static       float   countExtra   = (float) 0.5;
	static       float   infoCut      = (float) 0.95;
	static       float   snpRatio     = (float) 0.001;
	static       float   snpPer       = (float) 0.85;
	static       float   snpPerWHomo  = (float) 0.85;
	static       float   snpPerWHetero= (float) 0.33;
	static       float   snpDirected  = (float) 0.1;
	// static       int     snpMinCoverHomo   = 3;
	// static       int     snpMinCoverHetero = 4;
	// static       int     snpMinCoverWk     = 1;
	// static       float   snpPerWHomoWk   = (float) 0.7;
	// static       float   snpPerWHeteroWk = (float) 0.25;
	static       int     maxClusterSize  = 50;
	static       float   snpMinWeight    = (float) 0.5;

	static       int[]   refSeqSize;
	static final int     buffSize = 2560000;
	static       int     CNVcomp = 1000;
	static       int     coverageUnit = 10;
	static       int     rangeScoreDist = 101;
	static final int     SET = 0;
	static final int     PET = 1;
	static final int     POSITIVE = 0;
	static final int     NEGATIVE = 1;

	static final int     F   = 0;
	static final int     R   = 1;
	static       int     pQuality = 1; // 1/5 for 40/30;
	static       boolean snpRef   = true; 
	static       boolean contDB   = false;
    static       int     mmHistSize = 1000;

	static final int     numberOfTimePoints = 10;
	static long[]        fStart        = new long[numberOfTimePoints];
	static int           fSize         = 50000000; // 50M record
	static int           fSortSize     =  4000000; //  4M record
	
	static final float   cutWeight = 0.08f;    // is used for filtering to ol1, = minWeight * oMxSize
	static       int     snpWeightCut  = 1;

	static final int     maxMu         = 127;           // used in CreateSequences

	static final int     maxId         = 2000000000;  // 1G
    static       int     map_HistSize  = 50;
    static public int    transposonMinSize = 100;
    static       int     extra0        = 2; // for mapping score oy u1

	//* Load
	static public int    seedSize      = 0;
	static public int    maxPrbLine    = 36;
	static public int    prbMxSize     = 100;

	// --- Dataset
	static public int    ETag       = SET;
	static public String DATASET    = "";
	static public String DATABASE   = ""; 
	// static public String NOISE_DATABASE   = "NOISE"; 
	// --- input reference sequences
	static public String ch_name1   = "";
	static public String[] SEQ_VAR  = {};
	static public String ch_name2   = "";
	static public String   outFile; // it is just "s"
	// --- paths
	static public String   pathDB;
	static public String   refSNPs;
	static public String   pathPRB;  
	static public String   pathData;
	static public String   pathOut; 
	static public String   pathRefSeq;
	static public String   pathKnownSNPs;
	// static public String   pathConRefSeq; // = "/projects/nmalhis/clean";
	static public String   pathMulti;
	static public String   pathParallel;
	static public int      numberOfMultiSets = 1;

	static public String host = "ensembl01";
    static public int    port = 3306;
    static public String dbname   = "caenorhabditis_elegans_core_49_180a";
    static public String SNPvardb = "caenorhabditis_elegans_variation_49_180a"; // "rattus_norvegicus_variation_48_34r"; 
    static public String user     = "ensembl";
    static public String password = "ensembl";
/*
	// -- C. Elegans
	final public static String CE_transcr_filepath = "/home/pubseq/transcriptome/Caenorhabditis_elegans/current/";
	final public static String CE_filepath = "/home/pubseq/genomes/Caenorhabditis_elegans/current/";
	final public static String CE_database = "caenorhabditis_elegans_core_49_180a";
	final public static String CE_SNPvardb = "caenorhabditis_elegans_variation_49_180a";
	final public static String[] CE_CHR  = {"I","II","III","IV","V","X"};	
	
	// -- Rat
	final static String[] RAT_CHR = {"1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","X","MT"};
	final static String RAT_filepath = "/home/pubseq/genomes/Rattus_norvegicus/current/";
	final static String RAT_transcr_filepath = "------";
	final static String RAT_database = "rattus_norvegicus_core_48_34r";
	final static String RAT_SNPvardb = "rattus_norvegicus_variation_48_34r";
 */
    
    
	static void delete(String file) {
		System.err.println("Deleting:\t" + file);
		File fl = new File(file);
        File[] files = fl.listFiles();
        for(int i=0; i<files.length; i++) {
            if(files[i].isDirectory()) {
            	delete(files[i].toString());
            }
           	files[i].delete();
        }
	}

	
	static public void displayMemory(String text) {
		System.out.print  (text);
		System.out.print  ("\tTotal Memory:\t" + Runtime.getRuntime().totalMemory() + "\tFree Memory:\t" + Runtime.getRuntime().freeMemory());
		System.out.println("\tUsed Memory:\t" + (Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory()));
	}
	
	static void getRefSeqSize() throws Exception {
		String line;
		StringTokenizer tokens;
		refSeqSize = new int[SEQ_VAR.length];
		System.err.println(Parameters.pathDB + Parameters.DATABASE + "refSeqSizes");
		BufferedReader reader = new BufferedReader(new FileReader(Parameters.pathDB + Parameters.DATABASE + "refSeqSizes"));
		for (int i = 0; i < refSeqSize.length; i++) {
			System.err.print(SEQ_VAR[i] + "\tSize:\t");
			line           = reader.readLine();
			tokens         = new StringTokenizer(line);	
			refSeqSize[i]  = new Integer(tokens.nextToken());
			System.err.println(refSeqSize[i]);
		}
		System.err.println();
	}

	static public int intTrim(double d) {
    	return (int) (d * 100 + 0.5);
    }

    public static void main(String[] args) throws Exception {
		if (args.length < 1) {
			System.err.println("delete what?");
		} else {
			delete(args[0]);
		}
	}

    static void printTime(int tPoint)  throws Exception {
		if (tPoint < numberOfTimePoints && tPoint >= 0) {
			long fSec = (System.currentTimeMillis()-fStart[tPoint])/1000;
			long fMin = fSec / 60;
			long fHur = fSec / 3600;
			fSec = fSec - (fMin * 60);
			fMin = fMin - (fHur * 60);
			System.err.print("\t" + fHur + ":" + fMin + ":" + fSec);
			fStart[tPoint] = System.currentTimeMillis();
		}
	}

	static void read(String fl) throws Exception {
		String etag;
		String stk;
		String line;
		StringTokenizer st;
		// Maximum use of  for 
		System.err.println("\n\n\tSliderII Ver 1.0 Mar. 23 2009\n" +
				"\tAlignment of the short Illumina sequence reads and high quality SNP detection");
		System.err.println("\tBy: Nawar Malhis");
		System.err.println("\tCanada's Michael Smith Genome Sciences Centre, Vancouver\n\n");
		dbOligoSize = now * wordSize;
		try {
			BufferedReader reader = new BufferedReader(new FileReader(fl));
			
			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				System.err.println(line);
				return;
			}
			stk = st.nextToken();
			stk = st.nextToken();
			seedSize = new Integer(stk).intValue();
			
			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				System.err.println(line);
				return;
			}
			stk = st.nextToken();
			stk = st.nextToken();
			skipCycles = new Integer(stk).intValue();

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				System.err.println(line);
				return;
			}
			stk = st.nextToken();
			etag = st.nextToken();
			if(etag.compareTo("SET") == 0) {
				ETag = SET;
			} else if(etag.compareTo("PET") == 0) {
				ETag = PET;
			} // oneSnpEach

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				System.err.println(line);
				return;
			}
			stk = st.nextToken();
			oneSnpEach = new Integer(st.nextToken()).intValue();

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				System.err.println(line);
				return;
			}
			stk = st.nextToken();
			DATASET = st.nextToken();
			
			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			refSNPs = DATABASE = st.nextToken();
/*
			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			refSNPs = st.nextToken();
//*/
			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			pathRefSeq = st.nextToken();

			line = reader.readLine();
			st = new StringTokenizer(line);
			stk = st.nextToken();
			if (st.hasMoreTokens()) {
				pathKnownSNPs = st.nextToken();
			}

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			pathDB = st.nextToken();

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			pathPRB = st.nextToken();

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			pathData = st.nextToken();

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			if (st.hasMoreTokens()) {
				ch_name1 = st.nextToken();
			}

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			int sz = st.countTokens() - 1;
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			SEQ_VAR = new String[sz];
			for (int i = 0; i < sz; i++) { // countTokens() 
				SEQ_VAR[i] = st.nextToken();
		    }

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			if (st.hasMoreTokens()) {
				ch_name2 = st.nextToken();
			} else {
				ch_name2 = "";
			}
			
			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			if (st.hasMoreTokens()) {
				pathMulti = st.nextToken();
			} else {
				pathMulti = "";
			}

			line = reader.readLine();
			st = new StringTokenizer(line);
			if (!st.hasMoreTokens()) {
				return;
			}
			stk = st.nextToken();
			if (st.hasMoreTokens()) {
				pathParallel = st.nextToken();
			} else {
				pathParallel = "";
			}

			// System.out.println("pathMulti:\t" + pathMulti); // ch_name2 pathMulti pathParallel
			
			reader.close();
			
			
			// pathPRB    += DATASET;  
			pathData   += DATASET;  
			// pathConRefSeq = pathData + "contamination/"; 
			pathOut    = pathData + "Results/"; 
			outFile    = "s";
			// System.err.println("------------------------------->" + pathData);
		} catch (Exception er) {
			System.err.println("Parameters input file not found:\n\tinput/" + fl);
		}
		// cutWeight = minWeight * seedSize;
		for (int q = -40; q <= 40; q++) {
			Seq.qCal[q+40] = (float) (1/(1+Math.pow(10,(((float)-q)/10))));
		}
		seqSegNucP = Seq.qCal[seqSegPRB + 40];
		minWeight  = 1 - seqSegNucP; 
	}

	static void resetTime() {
		fStart[0] = System.currentTimeMillis();
		for (int i = 1; i < numberOfTimePoints; i++) {
			fStart[i] = fStart[0];
		}

	}
	
	static public float trim(double d) {
    	return ((float) ((int) (d * 100 + 0.5))) / 100;
    }

	static public int defalutQ(int i, int q) {
		return (int) Math.round(((float) q * q_Cal[i]) / 40.0);
	}
	
	static public float Q2P(int q) {
		return (float) (1/(1+Math.pow(10,(((float)-q)/10))));
	}
	static public int P2Q(float p) {
		if (p < 0.00001)
			return -40;
		else if (p > 0.99999)
			return 40;
		else
			return (int) Math.round(10 * Math.log(p / (1.0 - p)) / Math.log(10) ); // Math.round(  -10.0 * Math.log(p / (1.0 - p)) / Math.log(Math.E)       );
	}
}

