// package JavaCode;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;

import com.sun.org.apache.xalan.internal.xsltc.runtime.Hashtable;

public class ScoreResults {

	static private int[][]    counts   = new int[2][101];
	static private int[][][]  countsBi = new int[2][15][101];
	static Hashtable ht = new Hashtable(200);

	public static void main(String[] args) throws Exception {
		int coverage;
		int bi;
		Parameters.resetTime();
		if (args.length < 1) {
			return;
		}
		Parameters.read(args[0]);
		for (int chr = 0; chr < Parameters.SEQ_VAR.length; chr++) {
			ht.put(Parameters.SEQ_VAR[chr], chr);
		}
		for (int chr = 0; chr < Parameters.SEQ_VAR.length; chr++) {
			System.err.println((getChr(Parameters.SEQ_VAR[chr]) +1) + "\t" + chr);
		}
		BufferedWriter bwOut = new BufferedWriter(new FileWriter(Parameters.pathOut + "filter/snpsScores.txt"));
		int kLocation;
		int dLocation;
		int dScore;
		String dLine;
		String kLine;
		String tkn;
		StringTokenizer st;
		StringTokenizer kSt;
		for (int i = 0; i < 2; i++) {
			for (int j = 0; j < 101; j++) {
				counts[i][j] = 0;
				for (int k = 0; k < 15; k++)
					countsBi[i][k][j] = 0;
			}
		}
		for (int chr = 0; chr < Parameters.SEQ_VAR.length; chr++) {
			String kFile = Parameters.pathRefSeq + Parameters.SEQ_VAR[chr] + ".skSNPs";
			String dFile = Parameters.pathOut + "filter/" + Parameters.ch_name1 + Parameters.SEQ_VAR[chr] + Parameters.ch_name2 + ".snps";
			String doFile = Parameters.pathOut + "filter/" + Parameters.ch_name1 + Parameters.SEQ_VAR[chr] + Parameters.ch_name2 + ".snpScored";
			System.err.println(kFile + "\n" + dFile + "\n" + doFile);
			BufferedReader brk = new BufferedReader(new FileReader(kFile));
			BufferedReader brd = new BufferedReader(new FileReader(dFile));
			BufferedWriter bwd = new BufferedWriter(new FileWriter(doFile));
			dLocation = 0;
			kLocation = 0;
			while (brd.ready()) {
				dLine = brd.readLine();
				if (dLine.length() > 5) {
					st = new StringTokenizer(dLine);
					dScore = Integer.valueOf(st.nextToken());
					st.nextToken();
					tkn = st.nextToken();
					dLocation = Integer.valueOf(tkn);
					st.nextToken();
					st.nextToken();
					st.nextToken();
					st.nextToken();
					st.nextToken();
					coverage = Integer.valueOf(st.nextToken());
					if (coverage > 14) {
						coverage = 14;
					}
					bi       = Integer.valueOf(st.nextToken());
					if (bi > 100)
						bi = 100;
					// System.err.println(dLine + "\t" + coverage + "\t" + bi);
					while (dLocation > kLocation && brk.ready()) {
						kLine = brk.readLine();
						if (kLine.length() > 3) {
							kSt = new StringTokenizer(kLine);
							tkn = kSt.nextToken();
							kLocation = Integer.valueOf(tkn);
						}
					}
					if (kLocation == dLocation) {
						bwd.write("T\t");
						counts[0][dScore]++;
						countsBi[0][coverage][bi]++;
					} else {
						bwd.write("N\t");
						counts[1][dScore]++;
						countsBi[1][coverage][bi]++;
					}
					bwd.write(dLine + "\n");
				}
			}
			brk.close();
			brd.close();
			bwd.close();
		}
		for (int b = 0; b < 101; b++) {
			bwOut.write("" + b);
			for (int c = 1; c < 15; c++) {
				if ((countsBi[0][c][b] + countsBi[1][c][b]) > 0)
					bwOut.write("\t" + ((float) countsBi[0][c][b]) / (countsBi[0][c][b] + countsBi[1][c][b]));
				else
					bwOut.write("\tNAN");
			}
			bwOut.write("\n");
		}
		bwOut.write("\n");
		for (int j = 0; j < 101; j++) {
			bwOut.write("" + j);
			for (int i = 1; i >= 0; i--) {
				bwOut.write("\t" + counts[i][j]);
			}
			bwOut.write("\n");
		}
		bwOut.close();
	}

	static private int getChr(String chI) {
		Integer ch = (Integer) ht.get(chI);
		if (ch != null)
			return ch.intValue();
		else
			return -1;
	}
}
