// package JavaCode;

// import GSC_LAND.EvaluSNP;

// SNPid   Location        map     cmCount mCount  nmCount wSNP%   cSNP%   ncSNP%  cmScore nmScore1        
//         Ref     MPB     Pm(A)   Pm(C)   Pm(G)   Pm(T)   Pnm(A)  Pnm(C)  Pnm(G)  Pnm(T)
public class SNP implements Comparable<SNP> {
	public static final String SVNID = "$Id: SNP.java 38639 2008-05-13 21:06:44Z afejes $";
	
	String chr;
	int    SNPid;
	int    location;
	char   mpb;
	int    cmCount;
	int    mCount;
	int    nmCount;
	float  wSNP;
	float  cSNP;
	float  ncSNP;
	float  cmScore;
	float  nmScore;
	String ref;
	int    position;
	int    mapability;
	byte   strand;
		
	public SNP(String chr, int location, int pos, char mp, String rf, int id, int map, byte strd, int cmC, int mC, int nmC, 
			float wsnp, float csnp, float ncsnp, float cmscore, float nmscore) {
		this.chr      = chr;
		this.location = location;
		this.position = pos;
		this.mpb      = mp;
		this.ref      = new String(rf);
		this.SNPid    = id;
		this.mapability = map;
		this.strand     = strd;
		this.cmCount  = cmC;
		this.mCount   = mC;
		this.nmCount  = nmC;
		this.wSNP     = wsnp;
		this.cSNP     = csnp;
		this.ncSNP    = ncsnp;
		this.cmScore  = cmscore;
		this.nmScore  = nmscore;
	}
	
	public SNP() {
		// TODO Auto-generated constructor stub
	}
/*
	public SNP(SNP s) {
		
	}
	//*/
	public SNP copy_snp() {
		SNP B = new SNP(
						this.chr,
						this.location,
						this.position,
						this.mpb,
						this.ref, 
						this.SNPid,
						this.mapability,
						this.strand,
						this.cmCount,
						this.mCount,
						this.nmCount,
						this.wSNP,
						this.cSNP,
						this.ncSNP,
						this.cmScore,
						this.nmScore);
		return B;
	}
	//*
	public void set_position(int A) {
		this.position = A;
	}
	//*/
	public int get_id() {
		return this.SNPid;
	}
	
	
	public int compareTo(SNP o) {
		return this.location - o.location;
	}
	
	/**
	 * get chromosome - accessor function;
	 */
	final public String get_chromosome() {
		return this.chr;
	}
	
	/**
	 * get base - accessor function;
	 */
	final public char get_new_base() {
		return this.mpb;
	}
	
	final public char get_snp_cannonical() {
		return this.ref.charAt(2);
	}
	
	
	final public int get_location() {
		return this.location;
	}

	/**
	 * get position - accessor function;
	 */
	//*
	final public int get_position() {
		return this.position;
	}
	//*/
	/**
	 * subtract Y from current position
	 */
	/*
	public void addto_position(int Y) {
		this.ppos += Y;
	}
	//*/
}
